Index: channels/chan_iax2.c
===================================================================
--- channels/chan_iax2.c	(revision 34758)
+++ channels/chan_iax2.c	(working copy)
@@ -8309,6 +8309,7 @@
 	struct ast_ha *oldha = NULL;
 	int maskfound=0;
 	int found=0;
+	char *peersecret = NULL;
 
 	AST_LIST_LOCK(&peers);
 	if (!temponly) {
@@ -8352,6 +8353,8 @@
 		while(v) {
 			if (!strcasecmp(v->name, "secret")) {
 				ast_copy_string(peer->secret, v->value, sizeof(peer->secret));
+			} else if (!strcasecmp(v->name, "peersecret")) {
+				peersecret = strdupa(v->value);
 			} else if (!strcasecmp(v->name, "mailbox")) {
 				ast_copy_string(peer->mailbox, v->value, sizeof(peer->mailbox));
 			} else if (!strcasecmp(v->name, "dbsecret")) {
@@ -8485,6 +8488,8 @@
 	}
 	if (oldha)
 		ast_free_ha(oldha);
+	if (peersecret)
+		ast_copy_string(peer->secret, peersecret, sizeof(peer->secret));
 	return peer;
 }
 
